function pb = L1_projection(b,z)
if sum(abs(b))<=z
    pb=b;
else    
    n=length(b); 
    a=sort(abs(b));
    g=zeros(1,n);
    y=zeros(n,1);
    g0=sum(a)-z;
       for k=1:n-1
           g(k)=(k-n)*a(k)+sum(a(k+1:n))-z;
       end
       g(n)=-1;
       % Find LAMBDA
%_______________________________     
       if (g0>=0 && g(1)<=0)
          lambda=(sum(a(1:n))-z)/n;
       else
            for k=1:n
               if (g(k)>=0 && g(k+1)<=0)
                lambda=(sum(a(k+1:n))-z)/(n-k);
               end
            end
       end
       % Find PROJECTION
%______________________________       
       for k=1:n
          if b(k)<-lambda
                 y(k)=b(k)+lambda;
          elseif (b(k)>=-lambda) && (b(k)<=lambda)
               y(k)=0;
          elseif b(k)>lambda
               y(k)=b(k)-lambda;
          end
       end
  pb=y;
end
